Index: issm/trunk/src/m/classes/stochasticforcing.py
===================================================================
--- issm/trunk/src/m/classes/stochasticforcing.py	(revision 26744)
+++ issm/trunk/src/m/classes/stochasticforcing.py	(revision 26744)
@@ -0,0 +1,188 @@
+import numpy as np
+from checkfield import checkfield
+from fielddisplay import fielddisplay
+from WriteData import WriteData
+
+
+class stochasticforcing(object):
+    """STOCHASTICFORCING class definition
+
+    Usage:
+        stochasticforcing = stochasticforcing()
+    """
+
+    def __init__(self, *args):  # {{{
+        self.isstochasticforcing = 0
+        self.fields = np.nan
+        self.defaultdimension = 0
+        self.default_id = np.nan
+        self.covariance = np.nan
+        self.randomflag = 1
+
+        if len(args) == 0:
+            self.setdefaultparameters()
+        else:
+            raise RuntimeError('constructor not supported for stochasticforcing')
+
+    def __repr__(self):  # {{{
+        s = '   stochasticforcing parameters:\n'
+        s += '{}\n'.format(fielddisplay(self, 'isstochasticforcing', 'is stochasticity activated?'))
+        s += '{}\n'.format(fielddisplay(self, 'fields', 'fields with stochasticity applied, ex: [\'SMBautoregression\'], or [\'FrontalForcingsRignotAutoregression\']'))
+        s += '{}\n'.format(fielddisplay(self, 'defaultdimension', 'dimensionality of the noise terms (does not apply to fields with their specific dimension)'))
+        s += '{}\n'.format(fielddisplay(self, 'default_id', 'id of each element for partitioning of the noise terms (does not apply to fields with their specific partition)'))
+        s += '{}\n'.format(fielddisplay(self, 'covariance', 'covariance matrix for within- and between-fields covariance (units must be squared field units)'))
+        s += '{}\n'.format(fielddisplay(self, 'randomflag', 'whether to apply real randomness (true) or pseudo-randomness with fixed seed (false)'))
+        s += 'Available fields:\n'
+        s += '   DefaultCalving\n'
+        s += '   FloatingMeltRate\n'
+        s += '   SMBautoregression\n'
+        s += '   FrontalForcingsRignotAutoregression (thermal forcing)\n'
+        return s
+    #}}}
+
+    def setdefaultparameters(self):  # {{{
+        # Type of stabilization used
+        self.isstochasticforcing = 0 # stochasticforcing is turned off by default
+        self.fields = [] # Need to initialize to list to avoid "RuntimeError: object of type 'float' has no len()" on import of class
+        self.randomflag = 1 # true randomness is implemented by default
+        return self
+    #}}}
+
+    def checkconsistency(self, md, solution, analyses):  # {{{
+        # Early return
+        if not self.isstochasticforcing:
+            return md
+
+        num_fields = len(self.fields)
+
+        # Check that covariance matrix is positive definite (this is done internally by linalg)
+        try:
+            np.linalg.cholesky(self.covariance)
+        except:
+            raise TypeError('md.stochasticforcing.covariance is not positive definite')
+
+        # Check that all fields agree with the corresponding md class and if any field needs the default params
+        checkdefaults = False # Need to check defaults only if one of the fields does not have its own dimensionality
+        structstoch = self.structstochforcing()
+        for field in self.fields:
+            # Checking agreement of classes
+            if 'SMB' in field:
+                mdname = structstoch[field]
+                if (type(md.smb).__name__ != mdname):
+                    raise TypeError('md.smb does not agree with stochasticforcing field {}'.format(field))
+            if 'FrontalForcings' in field:
+                mdname = structstoch[field]
+                if (type(md.frontalforcings).__name__ != mdname):
+                    raise TypeError('md.frontalforcings does not agree with stochasticforcing field {}'.format(field))
+            if 'Calving' in field:
+                mdname = structstoch[field]
+                if (type(md.calving).__name__ != mdname):
+                    raise TypeError('md.calving does not agree with stochasticforcing field {}'.format(field))
+            if 'BasalforcingsFloatingice' in field:
+                mdname = structstoch[field]
+                if (type(md.basalforcings).__name__ != mdname):
+                    raise TypeError('md.basalforcings does not agree with stochasticforcing field {}'.format(field))
+            if 'WaterPressure' in field:
+                mdname = structstoch[field]
+                if (type(md.friction).__name__ != mdname):
+                    raise TypeError('stochasticforcing field {} is only implemented for default friction'.format(field))
+                if (md.friction.coupling!=0 and md.friction.coupling!=1 and md.friction.coupling!=2):
+                    raise TypeError('stochasticforcing field {} is only implemented for cases md.friction.coupling 0 or 1 or 2'.format(field))
+                if (np.any(md.friction.q==0)):
+                        raise TypeError('stochasticforcing field {} requires non-zero q exponent'.format(field))
+
+            # Checking for specific dimensions
+            if not (field == 'SMBautoregression' or field == 'FrontalForcingsRignotAutoregression'):
+                checkdefaults = True # field with non-specific dimensionality
+
+        # Retrieve sum of all the field dimensionalities
+        size_tot = self.defaultdimension * num_fields
+        indSMBar = -1 # About to check for index of SMBautoregression
+        indTFar = -1 # About to check for index of FrontalForcingsRignotAutoregression
+        if ('SMBautoregression' in self.fields):
+            size_tot = size_tot - self.defaultdimension + md.smb.num_basins
+            indSMBar = self.fields.index('SMBautoregression') # Index of SMBar, now check for consistency with TFar timestep (08Nov2021)
+        if ('FrontalForcingsRignotAutoregression' in self.fields):
+            size_tot = size_tot - self.defaultdimension + md.frontalforcings.num_basins
+            indTFar = self.fields.index('FrontalForcingsRignotAutoregression') # Index of TFar, now check for consistency with SMBar timestep (08Nov2021)
+        if (indSMBar != -1 and indTFar != -1): # Both autoregressive models are used: check autoregressive time step consistency
+            covsum = self.covariance[np.sum(self.defaultdimensions[0:indSMBar]).astype(int):np.sum(self.defaultdimensions[0:indSMBar + 1]).astype(int), np.sum(self.defaultdimensions[0:indTFar]).astype(int):np.sum(self.defaultdimensions[0:indTFar + 1]).astype(int)]
+            if((md.smb.ar_timestep != md.frontalforcings.ar_timestep) and np.any(covsum != 0)):
+                raise IOError('SMBautoregression and FrontalForcingsRignotAutoregression have different ar_timestep and non-zero covariance')
+
+        md = checkfield(md, 'fieldname', 'stochasticforcing.isstochasticforcing', 'values', [0, 1])
+        md = checkfield(md, 'fieldname', 'stochasticforcing.fields', 'numel', num_fields, 'cell', 1, 'values', self.supportedstochforcings())
+        md = checkfield(md, 'fieldname', 'stochasticforcing.covariance', 'NaN', 1, 'Inf', 1, 'size', [size_tot, size_tot])  # global covariance matrix
+        md = checkfield(md, 'fieldname', 'stochasticforcing.randomflag', 'numel', [1], 'values', [0, 1])
+        if (checkdefaults):
+            md = checkfield(md, 'fieldname', 'stochasticforcing.defaultdimension', 'numel', 1, 'NaN', 1, 'Inf', 1, '>', 0)
+            md = checkfield(md, 'fieldname', 'stochasticforcing.default_id','Inf',1,'NaN',1,'>=',0,'<=',self.defaultdimension,'size', [md.mesh.numberofelements])
+        return md
+    # }}}
+
+    def extrude(self, md):  # {{{
+        # Nothing for now
+        return self
+    # }}}
+
+    def marshall(self, prefix, md, fid):  # {{{
+        yts = md.constants.yts
+        num_fields = len(self.fields)
+
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'isstochasticforcing', 'format', 'Boolean')
+        if not self.isstochasticforcing:
+            return md
+        else:
+            # Retrieve dimensionality of each field
+            dimensions = self.defaultdimension * np.ones((num_fields,))
+            for ind, field in enumerate(self.fields):
+                # Checking for specific dimensions
+                if (field == 'SMBautoregression'):
+                    dimensions[ind] = md.smb.num_basins
+                if (field == 'FrontalForcingsRignotAutoregression'):
+                    dimensions[ind] = md.frontalforcings.num_basins
+
+            # Scaling covariance matrix (scale column-by-column and row-by-row)
+            scaledfields = ['DefaultCalving','FloatingMeltRate','SMBautoregression'] # list of fields that need scaling * 1/yts
+            tempcovariance = np.copy(self.covariance)
+            for i in range(num_fields):
+                if self.fields[i] in scaledfields:
+                    inds = range(int(np.sum(dimensions[0:i])), int(np.sum(dimensions[0:i + 1])))
+                    for row in inds:  # scale rows corresponding to scaled field
+                        tempcovariance[row, :] = 1 / yts * tempcovariance[row, :]
+                    for col in inds:  # scale columns corresponding to scaled field
+                        tempcovariance[:, col] = 1 / yts * tempcovariance[:, col]
+            # Set dummy default_id vector if defaults not used
+            if np.any(np.isnan(self.default_id)):
+                self.default_id = np.zeros(md.mesh.numberofelements)
+            # Reshape dimensions as column array for marshalling
+            dimensions = dimensions.reshape(1,len(dimensions))
+
+            WriteData(fid, prefix, 'data', num_fields, 'name', 'md.stochasticforcing.num_fields', 'format', 'Integer')
+            WriteData(fid, prefix, 'object', self, 'fieldname', 'fields', 'format', 'StringArray')
+            WriteData(fid, prefix, 'data', dimensions, 'name', 'md.stochasticforcing.dimensions', 'format', 'IntMat','mattype',2)
+            WriteData(fid, prefix, 'object', self, 'fieldname', 'default_id', 'format', 'IntMat', 'mattype', 2)  #12Nov2021 make sure this is zero-indexed!
+            WriteData(fid, prefix, 'object', self, 'fieldname', 'defaultdimension', 'format', 'Integer')
+            WriteData(fid, prefix, 'data', tempcovariance, 'name', 'md.stochasticforcing.covariance', 'format', 'DoubleMat')
+            WriteData(fid, prefix, 'object', self, 'fieldname', 'randomflag', 'format', 'Boolean')
+    # }}}
+
+    def supportedstochforcings(self):  # {{{
+        """Defines list of fields supported by the class md.stochasticforcing
+        """
+        list1 = self.structstochforcing()
+        list1 = list1.keys()
+        return list(list1)
+    #}}}
+
+    def structstochforcing(self):  # {{{
+        """Defines dictionary with list of fields
+           supported and corresponding md names
+        """
+        structure = {'DefaultCalving': 'calving',
+                     'FloatingMeltRate': 'basalforcings',
+                     'FrictionWaterPressure': 'friction',
+                     'FrontalForcingsRignotAutoregression': 'frontalforcingsrignotautoregression',
+                     'SMBautoregression': 'SMBautoregression'}
+        return structure
+    # }}}
Index: issm/trunk/src/m/classes/stressbalance.js
===================================================================
--- issm/trunk/src/m/classes/stressbalance.js	(revision 25994)
+++ issm/trunk/src/m/classes/stressbalance.js	(revision 26744)
@@ -158,11 +158,9 @@
 		WriteData(fid,prefix,'object',this,'class','stressbalance','fieldname','referential','format','DoubleMat','mattype',1);
 
-		var lx=NewArrayFill(this.loadingforce.length,0); for(var i=0;i<lx.length;i++)lx[i]=this.loadingforce[i][0];
-		var ly=NewArrayFill(this.loadingforce.length,0); for(var i=0;i<lx.length;i++)ly[i]=this.loadingforce[i][1];
-		var lz=NewArrayFill(this.loadingforce.length,0); for(var i=0;i<lx.length;i++)lz[i]=this.loadingforce[i][2];
-
-		WriteData(fid,prefix,'data',lx,'format','DoubleMat','mattype',1,'name','md.stressbalance.loadingforcex');
-		WriteData(fid,prefix,'data',ly,'format','DoubleMat','mattype',1,'name','md.stressbalance.loadingforcey');
-		WriteData(fid,prefix,'data',lz,'format','DoubleMat','mattype',1,'name','md.stressbalance.loadingforcez');
+		if (size(this.loadingforce,1)==3) {
+			WriteData(fid,prefix,'data',ArrayCol(this.loadingforce,0),'format','DoubleMat','mattype',1,'name','md.stressbalance.loadingforcex');
+			WriteData(fid,prefix,'data',ArrayCol(this.loadingforce,1),'format','DoubleMat','mattype',1,'name','md.stressbalance.loadingforcey');
+			WriteData(fid,prefix,'data',ArrayCol(this.loadingforce,2),'format','DoubleMat','mattype',1,'name','md.stressbalance.loadingforcez');
+		}
 
 		//process requested outputs
Index: issm/trunk/src/m/classes/stressbalance.m
===================================================================
--- issm/trunk/src/m/classes/stressbalance.m	(revision 25994)
+++ issm/trunk/src/m/classes/stressbalance.m	(revision 26744)
@@ -8,4 +8,8 @@
 		spcvx                  = NaN;
 		spcvy                  = NaN;
+		spcvx_base             = NaN;
+		spcvy_base             = NaN;
+		spcvx_shear            = NaN;
+		spcvy_shear            = NaN;
 		spcvz                  = NaN;
 		restol                 = 0;
@@ -32,4 +36,11 @@
 			self.loadingforce=project3d(md,'vector',self.loadingforce,'type','node');
 
+			% for MLHO
+			if md.flowequation.isMLHO
+				self.spcvx_base=project3d(md,'vector',self.spcvx_base,'type','node');
+				self.spcvy_base=project3d(md,'vector',self.spcvy_base,'type','node');
+				self.spcvx_shear=project3d(md,'vector',self.spcvx_shear,'type','poly','degree',4);
+				self.spcvy_shear=project3d(md,'vector',self.spcvy_shear,'type','poly','degree',4);
+			end
 		end % }}}
 		function self = stressbalance(varargin) % {{{
@@ -53,28 +64,28 @@
 		function self = setdefaultparameters(self) % {{{
 
-			 %maximum of non-linear iterations.
-			 self.maxiter=100;
-
-			 %Convergence criterion: absolute, relative and residual
-			 self.restol=10^-4;
-			 self.reltol=0.01;
-			 self.abstol=10;
-
-			 self.FSreconditioning=10^13;
-			 self.shelf_dampening=0;
-
-			 %Penalty factor applied kappa=max(stiffness matrix)*10^penalty_factor
-			 self.penalty_factor=3;
-
-			 %Stop the iterations of rift if below a threshold
-			 self.rift_penalty_threshold=0;
-
-			 %in some solutions, it might be needed to stop a run when only
-			 %a few constraints remain unstable. For thermal computation, this
-			 %parameter is often used.
-			 self.rift_penalty_lock=10;
-
-			 %output default:
-			 self.requested_outputs={'default'};
+			%maximum of non-linear iterations.
+			self.maxiter=100;
+
+			%Convergence criterion: absolute, relative and residual
+			self.restol=10^-4;
+			self.reltol=0.01;
+			self.abstol=10;
+
+			self.FSreconditioning=10^13;
+			self.shelf_dampening=0;
+
+			%Penalty factor applied kappa=max(stiffness matrix)*10^penalty_factor
+			self.penalty_factor=3;
+
+			%Stop the iterations of rift if below a threshold
+			self.rift_penalty_threshold=0;
+
+			%in some solutions, it might be needed to stop a run when only
+			%a few constraints remain unstable. For thermal computation, this
+			%parameter is often used.
+			self.rift_penalty_lock=10;
+
+			%output default:
+			self.requested_outputs={'default'};
 
 		end % }}}
@@ -123,4 +134,11 @@
 				md = checkfield(md,'fieldname','stressbalance.FSreconditioning','>',0);
 			end
+			% CHECK THIS ONLY WORKS FOR MLHO
+			if md.flowequation.isMLHO
+				md = checkfield(md,'fieldname','stressbalance.spcvx_base','Inf',1,'timeseries',1);
+				md = checkfield(md,'fieldname','stressbalance.spcvy_base','Inf',1,'timeseries',1);
+				md = checkfield(md,'fieldname','stressbalance.spcvx_shear','Inf',1,'timeseries',1);
+				md = checkfield(md,'fieldname','stressbalance.spcvy_shear','Inf',1,'timeseries',1);
+			end
 		end % }}}
 		function list=defaultoutputs(self,md) % {{{
@@ -150,4 +168,10 @@
 			fielddisplay(self,'spcvy','y-axis velocity constraint (NaN means no constraint) [m/yr]');
 			fielddisplay(self,'spcvz','z-axis velocity constraint (NaN means no constraint) [m/yr]');
+
+			disp(sprintf('\n      %s','MLHO boundary conditions:'));
+			fielddisplay(self,'spcvx_base','x-axis basal velocity constraint (NaN means no constraint) [m/yr]');
+			fielddisplay(self,'spcvy_base','y-axis basal velocity constraint (NaN means no constraint) [m/yr]');
+			fielddisplay(self,'spcvx_shear','x-axis shear velocity constraint (NaN means no constraint) [m/yr]');
+			fielddisplay(self,'spcvy_shear','y-axis shear velocity constraint (NaN means no constraint) [m/yr]');
 
 			disp(sprintf('\n      %s','Rift options:'));
@@ -202,4 +226,11 @@
 			end
 			WriteData(fid,prefix,'data',outputs,'name','md.stressbalance.requested_outputs','format','StringArray');
+			% for MLHO
+			if (md.flowequation.isMLHO)
+				WriteData(fid,prefix,'object',self,'class','stressbalance','fieldname','spcvx_base','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+				WriteData(fid,prefix,'object',self,'class','stressbalance','fieldname','spcvy_base','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+				WriteData(fid,prefix,'object',self,'class','stressbalance','fieldname','spcvx_shear','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+				WriteData(fid,prefix,'object',self,'class','stressbalance','fieldname','spcvy_shear','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			end
 		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
@@ -223,4 +254,8 @@
 			writejscellstring(fid,[modelname '.stressbalance.requested_outputs'],self.requested_outputs);
 
+			writejs1Darray(fid,[modelname '.stressbalance.spcvx_base'],self.spcvx_shear);
+			writejs1Darray(fid,[modelname '.stressbalance.spcvy_base'],self.spcvy_shear);
+			writejs1Darray(fid,[modelname '.stressbalance.spcvx_shear'],self.spcvx_shear);
+			writejs1Darray(fid,[modelname '.stressbalance.spcvy_shear'],self.spcvy_shear);
 		end % }}}
 	end
Index: issm/trunk/src/m/classes/stressbalance.py
===================================================================
--- issm/trunk/src/m/classes/stressbalance.py	(revision 25994)
+++ issm/trunk/src/m/classes/stressbalance.py	(revision 26744)
@@ -18,7 +18,11 @@
 
     def __init__(self):  # {{{
-        self.spcvx = float('NaN')
-        self.spcvy = float('NaN')
-        self.spcvz = float('NaN')
+        self.spcvx = np.nan
+        self.spcvy = np.nan
+        self.spcvx_base = np.nan
+        self.spcvy_base = np.nan
+        self.spcvx_shear = np.nan
+        self.spcvy_shear = np.nan
+        self.spcvz = np.nan
         self.restol = 0
         self.reltol = 0
@@ -26,19 +30,20 @@
         self.isnewton = 0
         self.FSreconditioning = 0
-        self.icefront = float('NaN')
+        self.icefront = np.nan
         self.maxiter = 0
         self.shelf_dampening = 0
-        self.vertex_pairing = float('NaN')
-        self.penalty_factor = float('NaN')
-        self.rift_penalty_lock = float('NaN')
+        self.vertex_pairing = np.nan
+        self.penalty_factor = np.nan
+        self.rift_penalty_lock = np.nan
         self.rift_penalty_threshold = 0
-        self.referential = float('NaN')
-        self.loadingforce = float('NaN')
+        self.referential = np.nan
+        self.loadingforce = np.nan
         self.requested_outputs = []
 
-    #set defaults
+        # Set defaults
         self.setdefaultparameters()
 
-    #}}}
+    # }}}
+
     def __repr__(self):  # {{{
         s = '   StressBalance solution parameters:\n'
@@ -47,16 +52,21 @@
         s += '{}\n'.format(fielddisplay(self, 'reltol', 'velocity relative convergence criterion, NaN: not applied'))
         s += '{}\n'.format(fielddisplay(self, 'abstol', 'velocity absolute convergence criterion, NaN: not applied'))
-        s += '{}\n'.format(fielddisplay(self, 'isnewton', "0: Picard's fixed point, 1: Newton's method, 2: hybrid"))
+        s += '{}\n'.format(fielddisplay(self, 'isnewton', '0: Picard\'s fixed point, 1: Newton\'s method, 2: hybrid'))
         s += '{}\n'.format(fielddisplay(self, 'maxiter', 'maximum number of nonlinear iterations'))
         s += '      boundary conditions:\n'
-        s += '{}\n'.format(fielddisplay(self, 'spcvx', 'x - axis velocity constraint (NaN means no constraint) [m / yr]'))
-        s += '{}\n'.format(fielddisplay(self, 'spcvy', 'y - axis velocity constraint (NaN means no constraint) [m / yr]'))
-        s += '{}\n'.format(fielddisplay(self, 'spcvz', 'z - axis velocity constraint (NaN means no constraint) [m / yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'spcvx', 'x-axis velocity constraint (NaN means no constraint) [m / yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'spcvy', 'y-axis velocity constraint (NaN means no constraint) [m / yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'spcvz', 'z-axis velocity constraint (NaN means no constraint) [m / yr]'))
         s += '{}\n'.format(fielddisplay(self, 'icefront', 'segments on ice front list (last column 0: Air, 1: Water, 2: Ice'))
-        s = "%s\n%s" % (s, '\n      Rift options:')
+        s += '      MLHO boundary conditions:\n'
+        s += '{}\n'.format(fielddisplay(self, 'spcvx_base', 'x-axis basal velocity constraint (NaN means no constraint) [m / yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'spcvy_base', 'y-axis basal velocity constraint (NaN means no constraint) [m / yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'spcvx_shear', 'x-axis shear velocity constraint (NaN means no constraint) [m / yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'spcvy_shear', 'y-axis shear velocity constraint (NaN means no constraint) [m / yr]'))
+        s += '      Rift options:\n'
         s += '{}\n'.format(fielddisplay(self, 'rift_penalty_threshold', 'threshold for instability of mechanical constraints'))
         s += '{}\n'.format(fielddisplay(self, 'rift_penalty_lock', 'number of iterations before rift penalties are locked'))
         s += '      Penalty options:\n'
-        s += '{}\n'.format(fielddisplay(self, 'penalty_factor', 'offset used by penalties: penalty = Kmax * 1.0**offset'))
+        s += '{}\n'.format(fielddisplay(self, 'penalty_factor', 'offset used by penalties: penalty = Kmax * 10^offset'))
         s += '{}\n'.format(fielddisplay(self, 'vertex_pairing', 'pairs of vertices that are penalized'))
         s += '      Other:\n'
@@ -64,8 +74,8 @@
         s += '{}\n'.format(fielddisplay(self, 'FSreconditioning', 'multiplier for incompressibility equation. Only for FS model'))
         s += '{}\n'.format(fielddisplay(self, 'referential', 'local referential'))
-        s += '{}\n'.format(fielddisplay(self, 'loadingforce', 'loading force applied on each point [N / m^3]'))
+        s += '{}\n'.format(fielddisplay(self, 'loadingforce', 'loading force applied on each point [N/m^3]'))
         s += '{}\n'.format(fielddisplay(self, 'requested_outputs', 'additional outputs requested'))
         return s
-    #}}}
+    # }}}
 
     def extrude(self, md):  # {{{
@@ -76,28 +86,40 @@
         self.loadingforce = project3d(md, 'vector', self.loadingforce, 'type', 'node')
 
+        if md.flowequation.isMLHO:
+            self.spcvx_base = project3d(md, 'vector', self.spcvx_base, 'type', 'node')
+            self.spcvy_base = project3d(md, 'vector', self.spcvy_base, 'type', 'node')
+            self.spcvx_shear = project3d(md, 'vector', self.spcvx_shear, 'type', 'poly', 'degree', 4)
+            self.spcvy_shear = project3d(md, 'vector', self.spcvy_shear, 'type', 'poly', 'degree', 4)
+
         return self
-    #}}}
+    # }}}
 
     def setdefaultparameters(self):  # {{{
-        #maximum of non - linear iterations.
+        # Maximum of non-linear iterations
         self.maxiter = 100
-        #Convergence criterion: absolute, relative and residual
-        self.restol = 1.0e-4
+
+        # Convergence criterion: absolute, relative and residual
+        self.restol = pow(10, -4)
         self.reltol = 0.01
         self.abstol = 10
-        self.FSreconditioning = 10**13
+
+        self.FSreconditioning = pow(10, 13)
         self.shelf_dampening = 0
-        #Penalty factor applied kappa = max(stiffness matrix) * 1.0**penalty_factor
+
+        # Penalty factor applied kappa = max(stiffness matrix) * 1.0^penalty_factor
         self.penalty_factor = 3
-        #Stop the iterations of rift if below a threshold
+
+        # Stop the iterations of rift if below a threshold
         self.rift_penalty_threshold = 0
-        #in some solutions, it might be needed to stop a run when only
-        #a few constraints remain unstable. For thermal computation, this
-        #parameter is often used.
+
+        # In some solutions, it might be needed to stop a run when only a few 
+        # constraints remain unstable. For thermal computation, this parameter 
+        # is often used.
         self.rift_penalty_lock = 10
-        #output default:
+
+        # Output default
         self.requested_outputs = ['default']
         return self
-    #}}}
+    # }}}
 
     def defaultoutputs(self, md):  # {{{
@@ -107,5 +129,5 @@
             list = ['Vx', 'Vy', 'Vel', 'Pressure']
         return list
-    #}}}
+    # }}}
 
     def checkconsistency(self, md, solution, analyses):  # {{{
@@ -131,13 +153,13 @@
         if not np.any(np.isnan(self.vertex_pairing)) and len(self.vertex_pairing) > 0:
             md = checkfield(md, 'fieldname', 'stressbalance.vertex_pairing', '>', 0)
-        #singular solution
+        # Singular solution
         #        if ~any((~isnan(md.stressbalance.spcvx) + ~isnan(md.stressbalance.spcvy)) == 2),
-        if not np.any(np.logical_and(np.logical_not(np.isnan(md.stressbalance.spcvx)), np.logical_not(np.isnan(md.stressbalance.spcvy)))):
+        if (not np.any(np.logical_or(np.logical_not(np.isnan(md.stressbalance.spcvx)), np.logical_not(np.isnan(md.stressbalance.spcvy))))) & (not np.any(md.mask.ocean_levelset>0)):
             print("\n !!! Warning: no spc applied, model might not be well posed if no basal friction is applied, check for solution crash\n")
-        #CHECK THAT EACH LINES CONTAINS ONLY NAN VALUES OR NO NAN VALUES
+        # CHECK THAT EACH LINES CONTAINS ONLY NAN VALUES OR NO NAN VALUES
         #        if any(sum(isnan(md.stressbalance.referential), 2)~=0 & sum(isnan(md.stressbalance.referential), 2)~=6),
         if np.any(np.logical_and(np.sum(np.isnan(md.stressbalance.referential), axis=1) != 0, np.sum(np.isnan(md.stressbalance.referential), axis=1) != 6)):
             md.checkmessage("Each line of stressbalance.referential should contain either only NaN values or no NaN values")
-        #CHECK THAT THE TWO VECTORS PROVIDED ARE ORTHOGONAL
+        # CHECK THAT THE TWO VECTORS PROVIDED ARE ORTHOGONAL
         #        if any(sum(isnan(md.stressbalance.referential), 2) == 0),
         if np.any(np.sum(np.isnan(md.stressbalance.referential), axis=1) == 0):
@@ -149,9 +171,14 @@
                 if np.abs(np.inner(item[0:2], item[3:5])) > sys.float_info.epsilon:
                     md.checkmessage("Vectors in stressbalance.referential (columns 1 to 3 and 4 to 6) must be orthogonal")
-        #CHECK THAT NO rotation specified for FS Grounded ice at base
+        # CHECK THAT NO rotation specified for FS Grounded ice at base
         if m.strcmp(md.mesh.domaintype(), '3D') and md.flowequation.isFS:
             pos = np.nonzero(np.logical_and(md.mask.ocean_levelset, md.mesh.vertexonbase))
             if np.any(np.logical_not(np.isnan(md.stressbalance.referential[pos, :]))):
                 md.checkmessage("no referential should be specified for basal vertices of grounded ice")
+        if md.flowequation.isMLHO:
+            md = checkfield(md, 'fieldname', 'stressbalance.spcvx_base', 'Inf', 1, 'timeseries', 1)
+            md = checkfield(md, 'fieldname', 'stressbalance.spcvy_base', 'Inf', 1, 'timeseries', 1)
+            md = checkfield(md, 'fieldname', 'stressbalance.spcvx_shear', 'Inf', 1, 'timeseries', 1)
+            md = checkfield(md, 'fieldname', 'stressbalance.spcvy_shear', 'Inf', 1, 'timeseries', 1)
         return md
     # }}}
@@ -188,3 +215,9 @@
             outputs = outputscopy
         WriteData(fid, prefix, 'data', outputs, 'name', 'md.stressbalance.requested_outputs', 'format', 'StringArray')
-    # }}}
+        # MLHO
+        if md.flowequation.isMLHO:
+            WriteData(fid, prefix, 'object', self, 'class', 'stressbalance', 'fieldname', 'spcvx_base', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1. / yts, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts)
+            WriteData(fid, prefix, 'object', self, 'class', 'stressbalance', 'fieldname', 'spcvy_base', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1. / yts, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts)
+            WriteData(fid, prefix, 'object', self, 'class', 'stressbalance', 'fieldname', 'spcvx_shear', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1. / yts, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts)
+            WriteData(fid, prefix, 'object', self, 'class', 'stressbalance', 'fieldname', 'spcvy_shear', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1. / yts, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts)
+    # }}}
